import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Component, EventEmitter, Inject, Output } from '@angular/core';
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';

@Component({
  selector: 'app-delete-role-modal',
  templateUrl: './delete-role-modal.component.html',
  styleUrl: './delete-role-modal.component.css'
})
export class DeleteRoleModalComponent {
  @Output() roleDeleted = new EventEmitter<void>();
  constructor(
    public dialogRef: MatDialogRef<DeleteRoleModalComponent>,
    @Inject(MAT_DIALOG_DATA) public data: any,
    private http: HttpClient
  ) {}

  onNoClick(): void {
    this.dialogRef.close();
  }

  onYesClick(): void {
    const apiUrl = `http://127.0.0.1:8080/user-groups/${this.data.uuid}`;
    const headers = new HttpHeaders({
      'Content-Type': 'application/ld+json'
    });

    this.http.delete(apiUrl, { headers: headers }).subscribe(
      () => {
        console.log('Role deleted successfully');
        this.roleDeleted.emit();
        this.dialogRef.close(true);
      },
      (      error: any) => {
        console.error('Error deleting role:', error);
        // Agregar alguna lógica para manejar el error en la interfaz de usuario
      }
    );
  }
}
